﻿using Infragistics.Controls.Grids;
using Infragistics.Controls.Grids.Primitives;
using Infragistics.Windows;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamGridScrollIntoViewCase
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ViewModel vm = new ViewModel();
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = vm;
        }

        private void scrollViewBtn_Click(object sender, RoutedEventArgs e)
        {
            int? index = null;

            try
            {
                index = int.Parse(indexTB.Text);
            }
            catch (Exception ex)
            {
                MessageBox.Show("Please enter a valid integer.");
            }

            if (index != null)
            {
                if (index < 0)
                {
                    MessageBox.Show("Please enter a value greater than 0");
                }
                else if (index > theGrid.Rows.Count - 1)
                {
                    MessageBox.Show("Please enter a value less than " + (vm.Data.Count - 1).ToString());
                }
                else
                {
                    RowsPanel rowPanel = Utilities.GetDescendantFromName(theGrid, "RowsPanel") as RowsPanel;

                    Row row = theGrid.Rows[(int)index];

                    var rowsInView = rowPanel.VisibleRows;
                                      
                    int inViewCount = rowsInView.Count();

                    int middleOfInViewCount = inViewCount / 2;

                    theGrid.SelectionSettings.SelectedRows.Clear();
                    theGrid.SelectionSettings.SelectedRows.Add(row);        

                    int firstViewedRecordIndex = rowsInView[0].Index;

                    int calculatedScrollIndex = 0;

                    ////First viewed record is below scroll-record. Else - above.
                    if (firstViewedRecordIndex <= index)
                    {
                        calculatedScrollIndex = (int)index + middleOfInViewCount;
                    }
                    else
                    {
                        calculatedScrollIndex = (int)index - middleOfInViewCount;
                    }


                    if (calculatedScrollIndex >= theGrid.Rows.Count - 1)
                    {
                        theGrid.ScrollCellIntoView(theGrid.Rows[theGrid.Rows.Count - 1].Cells[0]);
                    }
                    else if (calculatedScrollIndex <= 0)
                    {
                        theGrid.ScrollCellIntoView(theGrid.Rows[0].Cells[0]);
                    }
                    else
                    {
                        theGrid.ScrollCellIntoView(theGrid.Rows[calculatedScrollIndex].Cells[0]);
                    }
                }
            }
        }
    }
}
